<?php

namespace Treewec\DirectoryIterators;

/**
 * Test class for DirectoryOrder.
 * Generated by PHPUnit on 2012-07-04 at 09:38:15.
 * @group directory_iterators
 */
class DirectoryOrderTest extends \PHPUnit_Framework_TestCase {

    /** @var DirectoryOrder */
    private $object;

    protected function setUp() {
        $this->object = new DirectoryOrder();
        $this->object->changeDirectory(TEMP_FILEDIR);
    }

    public function testGetOrderArray() {        
        parent::assertTrue(is_array($this->object->getOrderArray()));
        $this->object = new DirectoryOrder();
        parent::assertTrue(is_array($this->object->getOrderArray()));
    }

    public function testChangeOrderArray() {
        $arrays = array(
            array(),
            array('hello', 'world')
        );
        foreach ($arrays as $array) {
            $this->object->changeOrderArray($array);
            parent::assertEquals($array, array_keys($this->object->getOrderArray()));
        }
    }

    public function testAddNewAtTop() {
        $newFilename = 'NEWFILENAME';
        $currentArray = $this->object->getOrderArray();
        $this->object->addNewAtTop($newFilename);
        $newArray = array_keys($this->object->getOrderArray());
        parent::assertEquals(count($currentArray) + 1, count($newArray));
        parent::assertEquals($newFilename, array_shift($newArray));
    }

    public function testAddNewAtBottom() {
        $newFilename = 'NEWFILENAME';
        $currentArray = array_keys($this->object->getOrderArray());
        $this->object->addNewAtBottom($newFilename);
        $newArray = array_keys($this->object->getOrderArray());
        parent::assertEquals(count($currentArray) + 1, count($newArray));
        parent::assertEquals($newFilename, array_pop($newArray));
    }

    public function testSaveOrder() {
        $newArray = array('hello', 'world');
        $currentArray = array_keys($this->object->getOrderArray());
        $this->object->changeOrderArray($newArray);
        if ($this->object->saveOrder()) {
            parent::assertEquals("hello\nworld", file_get_contents(TEMP_FILEDIR . 'dir.order'));            
            // back to previous state
            $this->object->changeOrderArray($currentArray);
            $this->object->saveOrder();
            parent::assertEquals(implode("\n", $currentArray), file_get_contents(TEMP_FILEDIR . 'dir.order'));
        }
    }

}

?>
